#ifndef QCVIMAGEPROCESSOR_H
#define QCVIMAGEPROCESSOR_H

#include <QObject>
#include <QCamera>
#include <QCameraImageCapture>
#include <QStandardPaths>
#include <QCoreApplication>
#include <QThread>
#include <QThreadPool>

#include "opencv2/opencv.hpp"

class QCvAlgorithm: public QObject
{
    Q_OBJECT

public:
    QString inputFileName; //处理前图像保持地址
    void doBit();
    void doCanny();
    void doGray();
    void doNone();

signals:
    void errorOccured(QString msg);
    void imageProcessed(QString fname);

};

class QCvImageProcessor : public QObject
{
    Q_OBJECT
public:
    explicit QCvImageProcessor(QObject *parent = 0);
    ~QCvImageProcessor();
    //大量采用函数引出
    Q_INVOKABLE void setCamera(QVariant v);
    Q_INVOKABLE void capture();
    Q_INVOKABLE void setAlgorithm(QString alg);

    Q_INVOKABLE void processEvents()
    {
        qApp->processEvents();
    }

     Q_INVOKABLE  void processSavedImage(const QString &fname);
signals:
    void errorOccured(QString msg);
    void imageProcessed(QString fname);
    void processStarted();

private:
    QCamera *camera;
    QCameraImageCapture *imageCapture;



    QCvAlgorithm *cvAlgorithm;
    QThread *workerThread;

    QString algorithm;

};

#endif // QCVIMAGEPROCESSOR_H
